﻿
init python:
    from copy import copy
    class word:
        def __init__(self, word, meaning, sound = None):
            self.word = word
            self.meaning = meaning
            self.sound = sound
            self.learned = False
            self.wrong = False
    class dictionary:
        def __init__(self, words):
            self.words = words
            self.test_words = None
            self.test_words_back_up = None
            self.current = None
            self.current_answer = ""
            self.settings = {
                "Sound on open": True,
            }

        def calculate_score(self):
            items = [i for i in self.test_words_back_up if i]
            correct = [i for i in items if i.learned]
            all = len(items)
            right = len(correct)
            return [all, right, all-right]

        def toggle_settings(self, item):
            self.settings[item] = not self.settings[item]
        def open_word(self, row, word):
            if self.settings["Sound on open"]:
                Play("sound", word.sound)()
            Show("dictionary_word", g = self, row = row, word = word)()
        def start_test(self, full = False, start_test = False):
            words = []
            for row in self.words:
                for i in row:
                    if i:
                        if full or not i.learned:
                            words.append(i)
            random.shuffle(words)
            self.test_words_back_up = words
            self.test_words = iter(words)
            self.next()
            Show("dictionary_test", g = self, start_test = start_test)()
        def answer(self):
            if self.current_answer == "":
                self.current.learned = False
                self.next()
                return
            if self.current_answer == self.current.meaning:
                self.current.learned = True
            else:
                self.current.learned = False
                self.current.wrong = True
            self.current_answer = ""
            self.next()
        def next(self):
            try:
                self.current = next(self.test_words)
            except:
                renpy.notify("End of test.")

screen dictionary_screen(g, start_test = False):
    style_prefix "dictionary"
    if start_test:
        on "show" action Function(g.start_test, full = True, start_test = True)
    else:
        vbox:
            box_wrap True
            for row in g.words:
                hbox:
                    for i in row:
                        if i == None:
                            button:
                                xysize 100,100 margin 5,5 background None
                        else:
                            button:
                                xysize 100,100 margin 5,5
                                if i.wrong:
                                    background "#613535"
                                if not i.learned:
                                    text i.word
                                action Function(g.open_word, row = row, word = i)
        vbox:
            align 1.0,1.0 offset -20,-20 spacing 20
            button:
                padding 20,10 align 1.0,1.0
                text "Done"
                action Return()
            button:
                padding 20,10 align 1.0,1.0
                text "Take a test"
                action Function(g.start_test)
            button:
                padding 20,10 align 1.0,1.0
                text "Take a full test"
                action Function(g.start_test, True)
screen dictionary_test(g, start_test = False):
    style_prefix "dictionary"
    if start_test:
        add "#1a1930e0"
    else:
        add "#1a1930"
    vbox:
        align .5,.5 spacing 20
        text g.current.word
        frame:
            xysize 400,60
            input value FieldInputValue(g, "current_answer") align .5,.5
        button:
            align 1.0,.5
            text "Enter"
            action Function(g.answer) keysym "K_RETURN"
    hbox:
        spacing 10 align .5,1.0 yoffset -20
        button:
            padding 20,10
            text "Pass"
            action Function(g.next)
        button:
            padding 20,10
            text "End test"
            if start_test:
                action Return(g), Hide("dictionary_test")
            else:
                action Hide("dictionary_test")


screen dictionary_word(g, row, word):
    style_prefix "dictionary"
    add "#1a1930dd"
    vbox:
        align .5,.5 spacing 10
        button:
            align .5,.5 padding 40,40
            vbox:
                text word.word
                text word.meaning
        button:
            align .5,.5 padding 40,20
            vbox:
                # text word.sound
                text "►"
            action Play("sound", word.sound)
            
    hbox:
        align .5,1.0 yoffset -120
        for i in row:
            if i == None:
                button:
                    xysize 100,100 margin 5,5 background None
            else:
                button:
                    xysize 100,100 margin 5,5
                    if i.wrong:
                        background "#613535"
                    if not i.learned:
                        text i.word
                    action Function(g.open_word, row = row, word = i)
    hbox:
        align .5,1.0 yoffset -20
        button:
            padding 20,10
            text "Close"
            action Hide("dictionary_word")


style dictionary_text:
    size 50 align (.5,.5)
    font "fonts/irohamaru-mikami-Regular.ttf"
style dictionary_button:
    background "#3c4b5c"
style dictionary_frame:
    background "#3c4b5c"

default basic_hiragana = dictionary(
    [
        [
            word("あ", "a", "learn hiragana/sounds/a.mp3"),
            word("い", "i", "learn hiragana/sounds/i.mp3"),
            word("う", "u", "learn hiragana/sounds/u.mp3"),
            word("え", "e", "learn hiragana/sounds/e.mp3"),
            word("お", "o", "learn hiragana/sounds/o.mp3"),
        ],
        [
            word("か", "ka", "learn hiragana/sounds/ka.mp3"),
            word("き", "ki", "learn hiragana/sounds/ki.mp3"),
            word("く", "ku", "learn hiragana/sounds/ku.mp3"),
            word("け", "ke", "learn hiragana/sounds/ke.mp3"),
            word("こ", "ko", "learn hiragana/sounds/ko.mp3"),
        ],
        [
            word("さ", "sa", "learn hiragana/sounds/sa.mp3"),
            word("し", "shi", "learn hiragana/sounds/shi.mp3"),
            word("す", "su", "learn hiragana/sounds/su.mp3"),
            word("せ", "se", "learn hiragana/sounds/se.mp3"),
            word("そ", "so", "learn hiragana/sounds/so.mp3"),
        ],
        [
            word("た", "ta", "learn hiragana/sounds/ta.mp3"),
            word("ち", "chi", "learn hiragana/sounds/chi.mp3"),
            word("つ", "tsu", "learn hiragana/sounds/tsu.mp3"),
            word("て", "te", "learn hiragana/sounds/te.mp3"),
            word("と", "to", "learn hiragana/sounds/to.mp3"),
        ],
        [
            word("な", "na", "learn hiragana/sounds/na.mp3"),
            word("に", "ni", "learn hiragana/sounds/ni.mp3"),
            word("ぬ", "nu", "learn hiragana/sounds/nu.mp3"),
            word("ね", "ne", "learn hiragana/sounds/ne.mp3"),
            word("の", "no", "learn hiragana/sounds/no.mp3"),
        ],
        [
            word("は", "ha", "learn hiragana/sounds/ha.mp3"),
            word("ひ", "hi", "learn hiragana/sounds/hi.mp3"),
            word("ふ", "fu", "learn hiragana/sounds/fu.mp3"),
            word("へ", "he", "learn hiragana/sounds/he.mp3"),
            word("ほ", "ho", "learn hiragana/sounds/ho.mp3"),
        ],
        [
            word("ま", "ma", "learn hiragana/sounds/ma.mp3"),
            word("み", "mi", "learn hiragana/sounds/mi.mp3"),
            word("む", "mu", "learn hiragana/sounds/mu.mp3"),
            word("め", "me", "learn hiragana/sounds/me.mp3"),
            word("も", "mo", "learn hiragana/sounds/mo.mp3"),
        ],
        [
            word("や", "ya", "learn hiragana/sounds/ya.mp3"),
            None,
            word("ゆ", "yu", "learn hiragana/sounds/yu.mp3"),
            None,
            word("よ", "yo", "learn hiragana/sounds/yo.mp3"),
        ],
        [
            word("ら", "ra", "learn hiragana/sounds/ra.mp3"),
            word("り", "ri", "learn hiragana/sounds/ri.mp3"),
            word("る", "ru", "learn hiragana/sounds/ru.mp3"),
            word("れ", "re", "learn hiragana/sounds/re.mp3"),
            word("ろ", "ro", "learn hiragana/sounds/ro.mp3"),
        ],
        [
            word("わ", "wa", "learn hiragana/sounds/wa.mp3"),
            None,
            None,
            None,
            word("を", "wo", "learn hiragana/sounds/wo.mp3"),
        ],
        [
            word("ん", "n", "learn hiragana/sounds/n.mp3"),
        ],
    ]  
    )
default hiraganas_extras = dictionary(
    [
        [
            None,
            word("ゐ", "i"),
            None,
            word("ゑ", "e"),
            None,
        ],
        [
            word("が", "ga"),
            word("ぎ", "gi"),
            word("ぐ", "gu"),
            word("げ", "ge"),
            word("ご", "go"),
        ],
        [
            word("ざ", "za"),
            word("じ", "zi"),
            word("ず", "zu"),
            word("ぜ", "ze"),
            word("ぞ", "zo"),
        ],
        [
            word("だ", "da"),
            word("ぢ", "ji"),
            word("づ", "zu"),
            word("で", "de"),
            word("ど", "to"),
        ],
        [
            word("ば", "ba"),
            word("び", "bi"),
            word("ぶ", "bu"),
            word("べ", "be"),
            word("ぼ", "bo"),
        ],
        [
            word("ぱ", "pa"),
            word("ぴ", "pi"),
            word("ぷ", "pu"),
            word("ぺ", "pe"),
            word("ぽ", "po"),
        ],
        [
            word("きゃ", "kya"),
            None,
            word("きゅ", "kyu"),
            None,
            word("きょ", "kyo"),
        ],
        [
            word("しゃ", "sha"),
            None,
            word("しゅ", "shu"),
            None,
            word("しょ", "sho"),
        ],
        [
            word("ちゃ", "cha"),
            None,
            word("ちゅ", "chu"),
            None,
            word("ちょ", "cho"),
        ],
        [
            word("にゃ", "nya"),
            None,
            word("にゅ", "nyu"),
            None,
            word("にょ", "nyo"),
        ],
        [
            word("ひゃ", "hya"),
            None,
            word("ひゅ", "hyu"),
            None,
            word("ひょ", "hyo"),
        ],
        [
            word("みゃ", "mya"),
            None,
            word("みゅ", "myu"),
            None,
            word("みょ", "myo"),
        ],
        [
            word("りゃ", "rya"),
            None,
            word("りゅ", "ryu"),
            None,
            word("りょ", "ryo"),
        ],
        [
            word("ぎゃ", "gya"),
            None,
            word("ぎゅ", "gyu"),
            None,
            word("ぎょ", "gyo"),
        ],
        [
            word("じゃ", "ja"),
            None,
            word("じゅ", "ju"),
            None,
            word("じょ", "jo"),
        ],
        [
            word("ぢゃ", "ja"),
            None,
            word("ぢゅ", "ju"),
            None,
            word("ぢょ", "jo"),
        ],
        [
            word("びゃ", "bya"),
            None,
            word("びゅ", "byu"),
            None,
            word("びょ", "byo"),
        ],
        [
            word("ぴゃ", "pya"),
            None,
            word("ぴゅ", "pyu"),
            None,
            word("ぴょ", "pyo"),
        ],
    ]  
    )
default full_hiragana = dictionary(
    [
        [
            word("あ", "a"),
            word("い", "i"),
            word("う", "u"),
            word("え", "e"),
            word("お", "o"),
        ],
        [
            word("か", "ka"),
            word("き", "ki"),
            word("く", "ku"),
            word("け", "ke"),
            word("こ", "ko"),
        ],
        [
            word("さ", "sa"),
            word("し", "shi"),
            word("す", "su"),
            word("せ", "se"),
            word("そ", "so"),
        ],
        [
            word("た", "ta"),
            word("ち", "chi"),
            word("つ", "tsu"),
            word("て", "te"),
            word("と", "to"),
        ],
        [
            word("な", "na"),
            word("に", "ni"),
            word("ぬ", "nu"),
            word("ね", "ne"),
            word("の", "no"),
        ],
        [
            word("は", "ha"),
            word("ひ", "hi"),
            word("ふ", "fu"),
            word("へ", "he"),
            word("ほ", "ho"),
        ],
        [
            word("ま", "ma"),
            word("み", "mi"),
            word("む", "mu"),
            word("め", "me"),
            word("も", "mo"),
        ],
        [
            word("や", "ya"),
            None,
            word("ゆ", "yu"),
            None,
            word("よ", "yo"),
        ],
        [
            word("ら", "ra"),
            word("り", "ri"),
            word("る", "ru"),
            word("れ", "re"),
            word("ろ", "ro"),
        ],
        [
            word("わ", "wa"),
            # word("ゐ", "i"),
            None,
            None,
            None,
            # word("ゑ", "e"),
            word("を", "wo"),
        ],
        [
            word("ん", "n"),
        ],
        [
            word("が", "ga"),
            word("ぎ", "gi"),
            word("ぐ", "gu"),
            word("げ", "ee"),
            word("ご", "go"),
        ],
        [
            word("ざ", "za"),
            word("じ", "zi"),
            word("ず", "zu"),
            word("ぜ", "ze"),
            word("ぞ", "zo"),
        ],
        [
            word("だ", "da"),
            word("ぢ", "ji"),
            word("づ", "zu"),
            word("で", "de"),
            word("ど", "to"),
        ],
        [
            word("ば", "ba"),
            word("び", "bi"),
            word("ぶ", "bu"),
            word("べ", "be"),
            word("ぼ", "bo"),
        ],
        [
            word("ぱ", "pa"),
            word("ぴ", "pi"),
            word("ぷ", "pu"),
            word("ぺ", "pe"),
            word("ぽ", "po"),
        ],
        [
            word("きゃ", "kya"),
            None,
            word("きゅ", "kyu"),
            None,
            word("きょ", "kyo"),
        ],
        [
            word("しゃ", "sha"),
            None,
            word("しゅ", "shu"),
            None,
            word("しょ", "sho"),
        ],
        [
            word("ちゃ", "cha"),
            None,
            word("ちゅ", "chu"),
            None,
            word("ちょ", "cho"),
        ],
        [
            word("にゃ", "nya"),
            None,
            word("にゅ", "nyu"),
            None,
            word("にょ", "nyo"),
        ],
        [
            word("ひゃ", "hya"),
            None,
            word("ひゅ", "hyu"),
            None,
            word("ひょ", "hyo"),
        ],
        [
            word("みゃ", "mya"),
            None,
            word("みゅ", "myu"),
            None,
            word("みょ", "myo"),
        ],
        [
            word("りゃ", "rya"),
            None,
            word("りゅ", "ryu"),
            None,
            word("りょ", "ryo"),
        ],
        [
            word("ぎゃ", "gya"),
            None,
            word("ぎゅ", "gyu"),
            None,
            word("ぎょ", "gyo"),
        ],
        [
            word("じゃ", "ja"),
            None,
            word("じゅ", "ju"),
            None,
            word("じょ", "jo"),
        ],
        [
            word("ぢゃ", "ja"),
            None,
            word("ぢゅ", "ju"),
            None,
            word("ぢょ", "jo"),
        ],
        [
            word("びゃ", "bya"),
            None,
            word("びゅ", "byu"),
            None,
            word("びょ", "byo"),
        ],
        [
            word("ぴゃ", "pya"),
            None,
            word("ぴゅ", "pyu"),
            None,
            word("ぴょ", "pyo"),
        ],
    ]  
    )

define Madelyn = Character("Madelyn")

label dictionary_screen_example:
    scene black
    Madelyn "Master?"
    Madelyn "MASTER!!"
    show bg room
    show madelyn normal
    with dissolve
    Madelyn "Master! You're dozing off again."
    "Huh?"
    Madelyn "Your trip is in weeks, you should be studying."
    "Oh, no I was just meditating."
    "Helps with soaking in what I've learned."
    Madelyn "Is that right?"
    Madelyn "Then you wouldn't mind a test, would you."
    "Test?"
    Madelyn "Yes, to see what you've soaked in?"
    "Right right. Of course I wouldn't."
label dictionary_screen_example_test:
    menu:
        "Test basic hiragana.":
            call screen dictionary_screen(basic_hiragana, True)
        "Test hiragana extras.":
            call screen dictionary_screen(hiraganas_extras, True)
        "Test full hiragana.":
            call screen dictionary_screen(full_hiragana, True)

    $ total, correct, mistakes = _return.calculate_score()

    Madelyn "[correct] correct out of [total]."
    if mistakes == 0:
        Madelyn "Perfect score."
        Madelyn "My apologies."
    elif mistakes < 5:
        Madelyn "Pretty good."
    elif mistakes < 10:
        Madelyn "Not bad."
    elif mistakes < 15:
        Madelyn "Not good enough."
    else:
        Madelyn "This is not acceptable."

    "Do you want to study more?"
    menu:
        "Learn basic hiragana.":
            call screen dictionary_screen(basic_hiragana)
        "Learn hiragana extras.":
            call screen dictionary_screen(hiraganas_extras)
        "Learn full hiragana.":
            call screen dictionary_screen(full_hiragana)
    Madelyn "Done?"
    Madelyn "Ready to take another test?"
    jump dictionary_screen_example_test